#include<bits/stdc++.h>
using namespace std;
string a,b;
map<long long,bool> dali;
long long kude[100001];
int main(){
    cin>>a;
    long long N;
    cin>>N;
    long long maxa=0,b1=1009,mod=10e9;
    for(long long i=0;i<N;i++){
        cin>>b;
        long long has=0;
        for(long long j=0;j<b.size();j++){
            has=has*b1+b[j];
            has%=mod;
        }
        //cout<<has<<endl;
        dali[has]=1;
    }
    for(long long i=0;i<a.size();i++){
        long long has=0;
        long long da=-1;
        for(long long j=i;j<a.size();j++){
            if(kude[j]!=0){
                j=kude[j];
            }
            has=has*b1+a[j];
            has%=mod;
            if(dali[has]){

                da=j;
                break;
            }
        }
        if(da!=-1){
            kude[i]=da+1;
            i=0;
        }
    }
    for(long long i=0;i<a.size();i++){
        if(kude[i]!=0){
            i=kude[i];
        }
        cout<<a[i];
    }
    cout<<endl;
    return 0;
}
